import os.path
import tempfile
import base64

class B64Convertor(object):
    @classmethod
    def base64_from_file(cls, filepath):
        """
        Transform a file info a base64 data
        """
        with open(filepath, "rb") as f:
            file_name = os.path.basename(filepath)
            file_content = f.read()

            return cls.base64_encode(file_name, file_content)

    @staticmethod
    def base64_encode(filename, filedata):
        """
        Get base64 data from filename and filecontnet
        """
        return "{};{}".format(
            filename.replace(";",""),
            base64.b64encode(filedata).decode("ascii"))

    @staticmethod
    def base64_decode(base64_data):
        filename, b64data = base64_data.split(';')
        filecontent = base64.b64decode(b64data)
        return filename, filecontent

    @classmethod
    def file_from_base64(cls, base64_data):
        """
        Get file form base64
        """
        filename, filecontent = cls.base64_decode(base64_data)

        dtemp = tempfile.mkdtemp()
        fn = os.path.join(dtemp, filename)
        with open(fn, "wb") as f:
            f.write(filecontent)
        return fn
